#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

void usage(void)
{
	printf("usage: cairo-launch app\n");
	exit(0);
}


pid_t launch(int argc, char** argv, int sleep_times)
{
	pid_t pid = 0;
	char* args[512] = {NULL};
	int i = 0;

	for(i = 0; i < argc; i ++)
	{
		args[i] = (char*)malloc(1024);
		strncpy(args[i], argv[i], 1023);
	}

	pid = fork();

	if(pid == 0)
	{
		if(sleep_times > 0)
		{
			sleep(sleep_times);
		}

		if(execvp(argv[1], argv + 1) != 0)
		{
			perror("cairo-launch");
		}
	}

	for(i = 0; i < argc; i ++)
	{
		free(args[i]);
	}

	if(pid == 0)
	{
		exit(0);
	}

	return pid;
}


int main(int argc, char** argv)
{
	int status = 0;
	char* args[2] = {NULL, NULL};

	pid_t pid = 0;
	pid_t pid_dock = 0;
	pid_t pid_clock = 0;

	if(argc < 2)
	{
		usage();
	}

	pid = launch(argc, argv, 0);

	args[0] = (char*)malloc(1024);
	args[1] = (char*)malloc(1024);

	strncpy(args[0], "", 1023);
	strncpy(args[1], "cairo-clock", 1023);
	pid_clock = launch(2, args, 2);

	strncpy(args[0], "", 1023);
	strncpy(args[1], "cairo-dock", 1023);
	pid_dock = launch(2, args, 2);


	free(args[0]);
	free(args[1]);

	waitpid(pid, &status, 0);

	kill(pid_clock, 9);
	kill(pid_dock, 9);
}

